###################################################
### chunk number 1: startup
###################################################
#line 77 "d:/Rcompile/CRANpkg/local/2.12/Cubist/inst/doc/cubist.Rnw"
library(mlbench)
data(BostonHousing)
library(Cubist)


###################################################
### chunk number 2: bh1
###################################################
#line 105 "d:/Rcompile/CRANpkg/local/2.12/Cubist/inst/doc/cubist.Rnw"
library(Cubist)
library(mlbench)
data(BostonHousing)
BostonHousing$chas <- as.numeric(BostonHousing$chas) - 1

set.seed(1)

inTrain <- sample(1:nrow(BostonHousing), floor(.8*nrow(BostonHousing)))

trainingPredictors <- BostonHousing[ inTrain, -14]
testPredictors     <- BostonHousing[-inTrain, -14]

trainingOutcome <- BostonHousing$medv[ inTrain]
testOutcome     <- BostonHousing$medv[-inTrain]

modelTree <- cubist(x = trainingPredictors, y = trainingOutcome)
modelTree


###################################################
### chunk number 3: bh2
###################################################
#line 124 "d:/Rcompile/CRANpkg/local/2.12/Cubist/inst/doc/cubist.Rnw"
summary(modelTree)


###################################################
### chunk number 4: bh3
###################################################
#line 130 "d:/Rcompile/CRANpkg/local/2.12/Cubist/inst/doc/cubist.Rnw"
mtPred <- predict(modelTree, testPredictors)
## Test set RMSE
sqrt(mean((mtPred - testOutcome)^2))
## Test set R^2
cor(mtPred, testOutcome)^2


###################################################
### chunk number 5: bh4
###################################################
#line 144 "d:/Rcompile/CRANpkg/local/2.12/Cubist/inst/doc/cubist.Rnw"
set.seed(1)
committeeModel <- cubist(x = trainingPredictors, y = trainingOutcome,
                         committees = 5)
summary(committeeModel)


###################################################
### chunk number 6: bh5
###################################################
#line 152 "d:/Rcompile/CRANpkg/local/2.12/Cubist/inst/doc/cubist.Rnw"
cmPred <- predict(committeeModel, testPredictors)
## RMSE
sqrt(mean((cmPred - testOutcome)^2))
## R^2
cor(cmPred, testOutcome)^2


###################################################
### chunk number 7: bh6
###################################################
#line 167 "d:/Rcompile/CRANpkg/local/2.12/Cubist/inst/doc/cubist.Rnw"
instancePred <- predict(committeeModel, testPredictors, neighbors = 5)
## RMSE
sqrt(mean((instancePred - testOutcome)^2))
## R^2
cor(instancePred, testOutcome)^2


###################################################
### chunk number 8: tune
###################################################
#line 181 "d:/Rcompile/CRANpkg/local/2.12/Cubist/inst/doc/cubist.Rnw"
library(caret)

set.seed(1)
cTune <- train(x = trainingPredictors, y = trainingOutcome,
               "cubist",
               tuneGrid = expand.grid(.committees = c(1, 10, 50, 100), 
                                      .neighbors = c(0, 1, 5, 9)),
               trControl = trainControl(method = "cv"))
cTune


###################################################
### chunk number 9: tune
###################################################
#line 200 "d:/Rcompile/CRANpkg/local/2.12/Cubist/inst/doc/cubist.Rnw"
trellis.par.set(caretTheme())
print(plot(cTune, aut.key = list(columns = 4)))


###################################################
### chunk number 10: lstat
###################################################
#line 212 "d:/Rcompile/CRANpkg/local/2.12/Cubist/inst/doc/cubist.Rnw"
lstat <- trainingPredictors[, "lstat", drop = FALSE]
justRules <- cubist(lstat, trainingOutcome)
andCommittees <- cubist(lstat, trainingOutcome, committees = 100)


###################################################
### chunk number 11: lstatPlot
###################################################
#line 225 "d:/Rcompile/CRANpkg/local/2.12/Cubist/inst/doc/cubist.Rnw"
lstatTest <- testPredictors[, "lstat", drop = FALSE]
newOrder <- order(lstatTest$lstat)
lstatTest <- lstatTest[newOrder,,drop = FALSE]
testOutcome <- testOutcome[newOrder]
plot(lstatTest$lstat, testOutcome,
     xlab = "lstat", ylab = "Median Home Value")
points(lstatTest$lstat, predict(justRules, lstatTest),
       type = "l", lwd = 2, col = "black")
points(lstatTest$lstat, predict(justRules, lstatTest, neighbors = 5),
       type = "l", lwd = 2, col = "blue")
points(lstatTest$lstat, predict(andCommittees, lstatTest),
       type = "l", lwd = 2, col = "darkred")
legend(20, 50,
       c("Rules", "100 Committees", "Rules + 5 Neighbors"),
       col = c("black", "darkred", "blue"),
       lwd = rep(2, 3))


###################################################
### chunk number 12: vimp
###################################################
#line 261 "d:/Rcompile/CRANpkg/local/2.12/Cubist/inst/doc/cubist.Rnw"
summary(modelTree)
modelTree$usage
library(caret)
varImp(modelTree)


###################################################
### chunk number 13: <session
###################################################
#line 321 "d:/Rcompile/CRANpkg/local/2.12/Cubist/inst/doc/cubist.Rnw"
toLatex(sessionInfo())


